// Tomado integramente de la web de IBM
// http://www-106.ibm.com/developerworks/java/library/position-layout-manager.html?dwzone=java
// Articulo titulado: Implementing a Position Layout Manager in Java
// Autor: Scott M. Consolatti
// Compaia: IBM
// Fecha: March 1998
// Modificaciones: David Portoles: 08/12/2001

package PositionLayoutManager;
         //--
         // An example showing how to create a container with a position
         // layout and how to add children components to it at various positions.
         //--
         import java.awt.*;
         import PositionLayout.*;

         public class PositionExample extends Frame
         {
           PositionExample()
           {
             super();
             setSize(400, 300);

             // Create and set a position layout
             PositionLayout posLayout = new PositionLayout();
             setLayout(posLayout);

             // Create children with various position constraints
             PositionConstraints pCons;

             pCons = new PositionConstraints();
             pCons.x = 300;
             pCons.y = 210;
             Button preferredSizeButton = new Button("x=300, y=210");
             posLayout.setConstraints(preferredSizeButton, pCons);
             add(preferredSizeButton);

             pCons = new PositionConstraints();
             pCons.x = 75;
             pCons.y = 50;
             pCons.width = 200;
             pCons.height = 60;
             Button fixedSizeButton = new Button("x=75, y=50, w=200, h=60");
             posLayout.setConstraints(fixedSizeButton, pCons);
             add(fixedSizeButton);

             pCons = new PositionConstraints();
             pCons.anchor = PositionConstraints.SOUTHWEST;
             Button anchorButton = new Button("Anchor southwest");
             posLayout.setConstraints(anchorButton, pCons);
             add(anchorButton);

             pCons = new PositionConstraints();
             pCons.anchor = PositionConstraints.NORTH;
             pCons.fill = PositionConstraints.HORIZONTAL;
             pCons.insets = new Insets(8, 8, 8, 8);
             Button insetButton = 
                     new Button("Anchor north, fill horizontal, inset 8");
             posLayout.setConstraints(insetButton, pCons);
             add(insetButton);

             pCons = new PositionConstraints();
             pCons.fill = PositionConstraints.BOTH;
             Button fillButton = new Button("Fill both");
             posLayout.setConstraints(fillButton, pCons);
             add(fillButton);
           }

           public static void main(String args[])
           {
             (new PositionExample()).setVisible(true);
           }
         }
