//****************************************************************
//	TRABAJO ISBC : INTEGRACION JAVA-JESS. CASO DEL ELEVADOR	
//****************************************************************
//
//	Fichero:	Visualizar.java
//	Autor:	Daniel Urieta Lopez
//	Modificado por:	
//	Proposito:	Contiene la clase Visualizar que es la 
//			ventana de aplicacion que informa del estado del
//			motor de inferencia Jess mediante mensajes en un
//			area de texto.
//
//****************************************************************

import java.awt.*;
import java.io.*;
import salir.CloseWindowAndExit;
import ISBC_JESS.*;


public class Visualizar extends Frame
{
    private Edificio edificio;  

    //Controlador que implementa ReteDisplay para realizar comunicacion con 
    //   un motor de inferencia Rete.
    public ControladorDisplay m_display;

  Visualizar(String title,Edificio E, String[] args)
  {
    //Pongo el titulo en la ventana
    super(title);

	edificio = E;


    //Creo un objeto controlador de el intercambio de informacion con el 
    //  motor de inferencia.
    m_display = new ControladorDisplay(edificio.controlador.r);
    
    //Agnado el area de texto del controlador a la ventana
    add("Center",m_display.panel());

    setSize(400,600);
    //Pongo una escucha para cerrar la aplicacion
    addWindowListener(new CloseWindowAndExit());
  }


  //Devuelve el PrintStream del controlador para enlazarlo con el motor de
  //  inferencia.
  public PrintStream output()
  {
	return m_display.stdout();
  }

  public ControladorDisplay display()
  {
	return m_display;
  }

}

